#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "log.h"
char* newstrcpy( char* s ) {
	if ( s == NULL ) {
		return( newstrcpy( "NULL" ));
	}
	//log_message1( "newstrcpy copying: ", newstrcpy( s ));
	int len = strlen( s ) + 1;
	char* result = (char*)malloc( len );
	strcpy( result, s );
	return( result );
}

void log_message( const char* s ) {
	if ( strlen( s ) > 0 ) {
		FILE* fp = fopen( "neatview.log", "a" );
		fprintf( fp, "%s\n", s );
		fclose( fp );
	}
}

void log_messagef( const char* s, float value ) {
	char buf[100];
	sprintf( buf, "%s '%f'", s, value );
	log_message( buf );
}

void log_message1( const char* s, const char* param ) {
	static char* buf = NULL;
	static unsigned int bufsize = 0;
	if (( strlen( s ) + strlen( param )) > bufsize ) {
		bufsize = strlen( s ) + strlen( param ) + 100;
		if ( buf != NULL ) {
			free( buf );
		}
		buf = (char*)malloc( bufsize );
	}
	if ( param == NULL ) {
		param = "NULL";
	}
	sprintf( buf, "%s \"%s\"", s, param );
	log_message( buf );
}
void log_messagei1( char* s, int param ) {
	char buf[100];
	sprintf( buf, "%s \"%d\"", s, param );
	log_message( buf );
}


void log_error( char* s ) {
	FILE* fp = fopen( "neatview.err", "a" );
	fprintf( fp, "%s\n", s );
	fclose( fp );
}

void log_error1( char* s, char* param ) {
	char buf[100];
	sprintf( buf, "%s %s", s, param );
	log_error( buf );
}

void log_command( char* command ) {
	int commandlen = strlen(( const char*) command );
	if (( commandlen > 0) && ( commandlen < 60)) {
		char lbuf[100];
		sprintf( lbuf, "command is '%s', length %d\n", command, strlen( (const char*)command ));
		log_message( lbuf );
	}
}
